import javafx.application.Application;
import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.PasswordField;
import javafx.scene.control.Slider;
import javafx.scene.control.TextField;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.HBox;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;

public class LoginDemoWithUserInputP5 extends Application {
	
	private static final String USER = "User name:";
	private static final String PW = "happysparky";
	Label userLabel;
	Button okBtn;
	PasswordField pwField;
	Stage stage;
	Button logOut;
	Scene scene;

	public static void main(String[] args) {
		launch(args);
	}

	@Override
	public void start(Stage stage) throws Exception {
		this.stage = stage;
		stage.setTitle("Please login");
		VBox root = new VBox();
		root.setSpacing(10);
		root.setPadding(new Insets(10));
		HBox userRow = new HBox();
		userRow.setSpacing(10);
		userLabel = new Label("");
		TextField userField = new TextField();
		userField.setPromptText("Enter your user name");
		userRow.getChildren().addAll(userLabel, userField);
		HBox pwRow = new HBox();
		pwRow.setSpacing(16);
		Label pwLabel = new Label("Password");
		pwField = new PasswordField();
		pwField.setPromptText("Enter your user password");
		pwRow.getChildren().addAll(pwLabel, pwField);
		HBox buttonRow = new HBox();
		buttonRow.setSpacing(10);
		buttonRow.setAlignment(Pos.CENTER_RIGHT);
		okBtn = new Button("Ok");
		okBtn.setOnAction(new InputHandler());
		
		Button cancelBtn = new Button("Cancel");
		
		Slider slider = new Slider();
		slider.setMin(0);
		slider.setMax(10);
		slider.setMajorTickUnit(5);
		slider.setMinorTickCount(4);
		slider.setShowTickMarks(true);
		slider.setShowTickLabels(true);
		slider.setSnapToTicks(true);
		slider.valueProperty().addListener(new InputHandler());
		slider.setValue(5);
		
		
		buttonRow.getChildren().addAll(slider,okBtn, cancelBtn);
		root.getChildren().addAll(userRow, pwRow, buttonRow);
		scene = new Scene(root);
		stage.setScene(scene);
		stage.setResizable(false);
		stage.sizeToScene();
		stage.show();
	}
	
	private class InputHandler implements ChangeListener<Number>, EventHandler<ActionEvent> {

		@Override
		public void changed(ObservableValue<? extends Number> observable, Number oldValue, Number newValue) {
			System.out.println("changed");
			userLabel.setText(USER.substring(0, newValue.intValue()));
		}

		@Override
		public void handle(ActionEvent event) {
			if (event.getSource() == okBtn) {
				if (pwField.getText().equals(PW)) {
					BorderPane root = new BorderPane();
					root.setCenter(new Label("You are authenticated!"));
					logOut = new Button("Log Out");
					logOut.setOnAction(new InputHandler());
					root.setBottom(logOut);
					stage.setScene(new Scene(root));
				}
			} else if (event.getSource() == logOut) {
				stage.setScene(scene);
			}
			
			
			
		}
		
		
		
	}

}
